/**
 * Copyright zahir ( http://wonderfl.net/user/zahir )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/b4Wn
 */

// forked from zahir's Intのread速度
// forked from zahir's 速度比較用テンプレ
/*
    あくまでも参考値。
    PCでは効果がなく感じてもスマートフォンとかではあるかも
*/
package {
    import flash.utils.ByteArray;
    import flash.events.MouseEvent;
    import flash.text.TextField;
    import flash.display.Sprite;
    import flash.utils.getTimer;
    
    public class FlashTest extends Sprite {
        private const LOOP:int = 1000000;
        private var t:TextField;
        
        public function FlashTest() {
            addChild( ( t= new TextField() ) ).width = t.height = 465;
            addEventListener( MouseEvent.CLICK, onClick );
            ex();
        }
        
        private function onClick( e:MouseEvent ):void
        {
            ex();
        }

        private function ex():void
        {
            var i:int = 0;                                      
            var time1:int;
            var time2:int;
            var recode:Array = [];
            var count:int = 0;
            t.text = "各 " + LOOP + " 回ループ\n\n";
            
            // ここから処理
            var str:String = "";
            var ba:ByteArray = new ByteArray();
            var a:int = 0x33, r:int = 0x66, g:int = 0x99, b:int = 0xCC;
            
            time1 = getTimer();
            for( i = 0; i<LOOP; i++ )
            {
                ba.length = 0;
                ba.writeByte(a);
                ba.writeByte(r);
                ba.writeByte(g);
                ba.writeByte(b);
            }
            time2 = getTimer() - time1;
            recode[count++] = new TimeData( "byte * 4", time2, str + "");
            
            
            time1 = getTimer();
            for( i = 0; i<LOOP; i++ )
            {
                ba.length = 0;
                ba.writeInt( a << 24 | r << 16 | g << 8 | b );
            }
            time2 = getTimer() - time1;
            recode[count++] = new TimeData( "Int * 1", time2, str );
            
            
            time1 = getTimer();
            for( i = 0; i<LOOP; i++ )
            {
               ba.length = 0;
               ba.writeUnsignedInt( a << 24 | r << 16 | g << 8 | b );
            }
            time2 = getTimer() - time1;
            recode[count++] = new TimeData( "U_Int * 1", time2, str );
            
            time1 = getTimer();
            for( i = 0; i<LOOP; i++ )
            {
               ba.length = 0;
               var u:uint = a << 24 | r << 16 | g << 8 | b ;
               ba.writeUnsignedInt( u );
            }
            time2 = getTimer() - time1;
            recode[count++] = new TimeData( "U_Int * 1 計算した値", time2, str );
            
            // ここまで処理
            
            /* templete
            time1 = getTimer();
            for( i = 0; i<LOOP; i++ )
            {
                
            }
            time2 = getTimer() - time1;
            recode[count++] = new TimeData( "", time2, "" );
            */
            
            if( recode.length )
            {
                listup( recode );
            }
            
            t.appendText("clickで再計算");
        }
        private function listup( recode:Array ):void
        {
            var str:String = "";
            recode.sortOn( "time", Array.NUMERIC );
            var max:int = (recode[ recode.length - 1 ] as TimeData).time;
            for( var i:int = 0, len:int = recode.length; i<len; i++)
            {
                var data:TimeData = recode[i] as TimeData;
                var n:int = max / data.time * 100;
                str += data.title + " :: " + data.time + " ms\n\t\t最低速に比べて約 " + n + " %高速 \n";
                if(data.ms == "") str += "\n";
                else str += "\t\t" + data.ms  + "\n\n";
            }
            t.appendText( str );
        }
    }
}
class TimeData
{
    public var title:String;
    public var time:int;
    public var ms:String; // なんか、おまけ要素
    public function TimeData( title:String = "", time:int = 0 , ms:String = "")
    {
        this.title = title;
        this.time = time;
        this.ms = ms;
    }
}